# Example NATS chat application
This application is an example on how to use NATS in rust.
Features implemented are Authentication, Publish-Subscribe and Request-Reply.

## Starting the server
Go to nats-server directory and run the run.sh script.

## The client
Go to nats-client directory and execute `cargo run`

### Users
- admin is allowed everything
- client may pusblish and subscribe to the chat channel
- guest may only read chat messages

### Chat commands
- Writing anything will publish text as a messages
- "invalid" will send a non json string
- "request xyz" will send xyz as a request, getting an automated response
